include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "nat.ma".
axiom exp : nat -> nat -> nat.
axiom exp_body : nat -> nat -> nat.
axiom axiom_exp : \forall (n:nat). \forall (m:nat). (equal) (nat) ((exp)  n m) ((filter_nat_type) (nat) ((exp_body)  n) m).
definition eq_exp : \forall (n:nat). \forall (m:nat). (leibniz) (nat) ((exp)  n m) ((filter_nat_type) (nat) ((exp_body)  n) m) := \lambda n : nat. \lambda m : nat. ((((equal_leibniz) (nat)) ((exp)  n m)) ((filter_nat_type) (nat) ((exp_body)  n) m)) (((axiom_exp) (n)) (m)).
definition sym_eq_exp : \forall (n:nat). \forall (m:nat). (leibniz) (nat) ((filter_nat_type) (nat) ((exp_body)  n) m) ((exp)  n m) := \lambda n : nat. \lambda m : nat. ((((sym_leibniz) (nat)) ((exp)  n m)) ((filter_nat_type) (nat) ((exp_body)  n) m)) (((eq_exp) (n)) (m)).
axiom axiom_exp_body_O : \forall (n:nat). (equal) (nat) ((exp_body)  n (O) ) ((S)  (O) ).
definition eq_exp_body_O : \forall (n:nat). (leibniz) (nat) ((exp_body)  n (O) ) ((S)  (O) ) := \lambda n : nat. ((((equal_leibniz) (nat)) ((exp_body)  n (O) )) ((S)  (O) )) ((axiom_exp_body_O) (n)).
axiom axiom_exp_body_S : \forall (n:nat). \forall (m:nat). (equal) (nat) ((exp_body)  n ((S)  m)) ((times)  ((exp)  n m) n).
definition eq_exp_body_S : \forall (n:nat). \forall (m:nat). (leibniz) (nat) ((exp_body)  n ((S)  m)) ((times)  ((exp)  n m) n) := \lambda n : nat. \lambda m : nat. ((((equal_leibniz) (nat)) ((exp_body)  n ((S)  m))) ((times)  ((exp)  n m) n)) (((axiom_exp_body_S) (n)) (m)).
definition sym_eq_exp_body_S : \forall (n:nat). \forall (m:nat). (leibniz) (nat) ((times)  ((exp)  n m) n) ((exp_body)  n ((S)  m)) := \lambda n : nat. \lambda m : nat. ((((sym_leibniz) (nat)) ((exp_body)  n ((S)  m))) ((times)  ((exp)  n m) n)) (((eq_exp_body_S) (n)) (m)).
